<template>
  <div class="sellReturn pagePadding">
    <div
      v-if=" powers.some((i) => i == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="24">
                <!-- 时间区间 -->
                <el-col :span="6" style="width: 303px; padding: 0 0 0 0px">
                  <period-date-picker
                    :type="1"
                    :width="'135px'"
                    :size="searchSize"
                    :start="parmValue.start"
                    :end="parmValue.end"
                    @timeReturned="handleTime"
                  />
                </el-col>
                <el-col :span="4" style="width: 150px; padding: 0 0 0 0px">
                  <el-select
                    :size="searchSize"
                    v-model="parmValue.status"
                    filterable
                    clearable
                    placeholder="退货单状态"
                    style="width: 100%"
                    @change="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                    <el-option
                      v-for="item in statusOptions"
                      :key="'status' + item.id"
                      :label="item.label"
                      :value="item.id"
                    />
                  </el-select>
                </el-col>
                <el-col :span="6" style="width: 400px; padding: 0 0 0 10px">
                  <el-input
                    clearable
                    placeholder="关键字"
                    v-model="s_input"
                    maxlength="40"
                    :size="searchSize"
                    class="input-with-select"
                  >
                    <el-select
                      v-model="select"
                      style="width: 150px"
                      slot="prepend"
                      placeholder="关键字类型"
                    >
                      <el-option label="销售退货单编号" value="returnCode" />
                      <el-option label="销售订单编号" value="orderCode" />
                      <el-option label="申请人部门" value="company_name" />

                      <el-option label="申请人" value="apply_name" />
                    </el-select>
                    <el-button
                      slot="append"
                      icon="el-icon-search"
                      @click="
                        pageInfo.curr = 1;
                        parmValue.page = 1;
                        searchList();
                      "
                    ></el-button>
                  </el-input>
                </el-col>

                <el-col
                  :span="4"
                  class="fr"
                  style="width: 66px; padding: 0 0 0 10px"
                >
                  <el-button
                    type="warning"
                    class="fr"
                    :size="searchSize"
                    @click="restSearch"
                  >
                    重置
                  </el-button>
                </el-col>
                <el-col :span="3" style="width: 66px; float: right">
                  <el-button
                    :size="searchSize"
                    type="primary"
                    style="float: right; margin-left: 5px"
                    @click="searchList"
                  >
                    刷新
                  </el-button>
                </el-col>
              </el-col>
            </el-row>
            <el-row style="padding: 10px 0 0 0"> </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="getRouter('sellReturnDetail', scope.row.returnCode)"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import columns from "./columns";
import asyncRequest from "@/apis/service/sellOut/sellReturn";
import { mapGetters } from "vuex";

export default {
  name: "sellReturn",
  mixins: [mixinPage, resToken],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "sellReturn"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "returnCode", //默认选择下拉框
      s_input: "", //搜索框内容
      sitem: null,
      // 状态
      statusOptions: [
        { id: "1", label: "待业务审批" },
        { id: "2", label: "待专员审批" },
        { id: "3", label: "待主管审批" },
        { id: "4", label: "退货完成" },
        { id: "5", label: "业务驳回" },
        { id: "6", label: "采购驳回" },
        { id: "7", label: "专员审批不通过" },
      ],
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        returnCode: "", //销售退货code
        orderCode: "", //销售订单code
        company_name: "",
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
        order_type: "",
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue);
      const { page, size } = this.parmValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      // if(this.parmValue.companyNo.length>0){
      //     this.customerCode = [this.parmValue.companyNo] ;
      // }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.s_input = this.parmValue.s_input;
    } else {
      this.select = "returnCode";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          // type: 'view',
        };

        //有多选框的条件
        this.parmValue.select = this.select;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.s_input = this.s_input;
        //
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      this.s_input = ""; //清除输入框内容
      this.select = ""; //清除下拉框选中项
      this.parmValue = {
        order_type: "",
        company_name: "", //申请人部门

        returnCode: "", //销售退货code
        orderCode: "", //销售订单code
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      this.parmValue.returnCode =
        this.select === "returnCode" ? this.s_input : "";
      this.parmValue.orderCode =
        this.select === "orderCode" ? this.s_input : "";
      this.parmValue.apply_name =
        this.select === "apply_name" ? this.s_input : "";
      this.parmValue.company_name =
        this.select === "company_name" ? this.s_input : "";
      let model = JSON.parse(JSON.stringify(this.parmValue));

      const res = await asyncRequest.list(model);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    //物流公司查询
    async handleCompany(e) {
      console.log(e, "要求传快递简称，不传id"); //
      if (e && e.code) {
        this.parmValue.postCompany = [e.shortName];
        this.parmValue.page = 1;
      }
      await this.searchList();
    },

    // 时间
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }
      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
  },
};
</script>
   <style lang="scss" scoped>
.sellReturn {
}
</style>
   